﻿#Anmeldung wenn User MFA aktiviert hat:
import-module exchangeonlinemanagement
# Wichtig: *** ersetzen zuerst durch richtigen User-Name !!!
Connect-ExchangeOnline -UserPrincipalName *** -ShowProgress $true

# Diese sieben Rechte müssen vorhanden sein: Set-Contact / Get-Contact / Get-Recipient / Get-MailContact / Set-MailContact / New-MailContact / Remove-MailContact 
# Zuerst testen wir, welche Gruppen diese Rechte haben:
Get-ManagementRoleEntry *\Set-Contact
Get-ManagementRoleEntry *\Get-Contact
Get-ManagementRoleEntry *\Get-Recipient
Get-ManagementRoleEntry *\Get-MailContact
Get-ManagementRoleEntry *\Set-MailContact
# Diese fünf sind in "Mail Recipients" vorhanden !

Get-ManagementRoleEntry *\New-MailContact
Get-ManagementRoleEntry *\Remove-MailContact 
# Diese zwei sind in "Mail Recipient Creation" vorhanden

# Nun prüfen wir, welche anderen Recht diese beiden Rollen haben:
Get-ManagementRoleEntry "Mail Recipients\*"
Get-ManagementRoleEntry "Mail Recipient Creation\*"
#Alle Rechte ausser die obigen 5 und 2 müssen entfernt werden. Rechte Entfernen kann man aber nicht von Default Gruppen, also muss man diese zuerst Kopieren und dann von der Kopie entfernen...

# Also müssen wir diese beiden Management Roles kopieren:
New-ManagementRole –Name "Contact-Editors" –Parent “Mail Recipient Creation”
New-ManagementRole –Name "Contact-Editors1" –Parent “Mail Recipients”

# Prüfung aller Rechte auf den Kopierten Gruppen:
Get-ManagementRoleEntry "Contact-Editors\*"
Get-ManagementRoleEntry "Contact-Editors1\*"

# Nun müssen fast alle Rechte raus löschen, man kann nicht alle Löschen, da eines noch drin bleiben muss. Dieser Befehl würde alle Rechte löschen:
# Get-ManagementRoleEntry "Contact-Editors\*" | Where-Object {$_.Name -like '*'} | %{Remove-ManagementRoleEntry -Identity "$($_.id)\$($_.name)"}
# Den könnte man dann laufen lassen und einzeln wählen für jedes Recht mit Yes oder No, ob es entfernt werden soll. Das es eher mühsam ist, die richtigen Rechte einzeln mit No zu bestätigen 
# (für Löschen) und alle anderen mit Yes für Löschen, löschen wir zuerst alle, die nicht gebraucht werden und fügen danach wieder die nötigen dazu:
# Nach diesem Befehl immer bei allem Yes sagen - am einfachsten Y-Taste auf Tastatur jeweils drücken (wir löschen erst mal alle Get-Befehle und alles andere und behalten mal die Set- Befehle:
Get-ManagementRoleEntry "Contact-Editors1\*" | Where-Object {$_.Name -like 'Get-*'} | %{Remove-ManagementRoleEntry -Identity "$($_.id)\$($_.name)"}
Get-ManagementRoleEntry "Contact-Editors1\*" | Where-Object {$_.Name -like 'remove-*'} | %{Remove-ManagementRoleEntry -Identity "$($_.id)\$($_.name)"}
Get-ManagementRoleEntry "Contact-Editors1\*" | Where-Object {$_.Name -like 'test-*'} | %{Remove-ManagementRoleEntry -Identity "$($_.id)\$($_.name)"}
Get-ManagementRoleEntry "Contact-Editors1\*" | Where-Object {$_.Name -like 'u*'} | %{Remove-ManagementRoleEntry -Identity "$($_.id)\$($_.name)"}
Get-ManagementRoleEntry "Contact-Editors1\*" | Where-Object {$_.Name -like 'd*'} | %{Remove-ManagementRoleEntry -Identity "$($_.id)\$($_.name)"}
Get-ManagementRoleEntry "Contact-Editors1\*" | Where-Object {$_.Name -like 'a*'} | %{Remove-ManagementRoleEntry -Identity "$($_.id)\$($_.name)"}
Get-ManagementRoleEntry "Contact-Editors1\*" | Where-Object {$_.Name -like 'r*'} | %{Remove-ManagementRoleEntry -Identity "$($_.id)\$($_.name)"}
Get-ManagementRoleEntry "Contact-Editors1\*" | Where-Object {$_.Name -like 'n*'} | %{Remove-ManagementRoleEntry -Identity "$($_.id)\$($_.name)"}
Get-ManagementRoleEntry "Contact-Editors1\*" | Where-Object {$_.Name -like 'c*'} | %{Remove-ManagementRoleEntry -Identity "$($_.id)\$($_.name)"}
Get-ManagementRoleEntry "Contact-Editors1\*" | Where-Object {$_.Name -like 'e*'} | %{Remove-ManagementRoleEntry -Identity "$($_.id)\$($_.name)"}
Get-ManagementRoleEntry "Contact-Editors1\*" | Where-Object {$_.Name -like 'i*'} | %{Remove-ManagementRoleEntry -Identity "$($_.id)\$($_.name)"}
# Mal prüfen, jetzt sind es schon weniger, aber immer noch viele Befehle:
Get-ManagementRoleEntry "Contact-Editors1\*"
# Nun kann man den Befel für das Löschen aller Rechte eingeben, und dabei dann darauf achten, dass dieses stehen gelassen wird: 
Get-ManagementRoleEntry "Contact-Editors1\*" | Where-Object {$_.Name -like '*'} | %{Remove-ManagementRoleEntry -Identity "$($_.id)\$($_.name)"}

# Nun kann man die andrern gebrauchten Rechte noch hinzufügen, falls diese gelöscht wurden:
Add-ManagementRoleEntry "Contact-Editors1\Set-Contact"
Add-ManagementRoleEntry "Contact-Editors1\Get-Contact"
Add-ManagementRoleEntry "Contact-Editors1\Get-Recipient"
Add-ManagementRoleEntry "Contact-Editors1\Get-MailContact"
Add-ManagementRoleEntry "Contact-Editors1\Set-MailContact"

# Nochmals prüfen, ob nun alle 5 Rechte und nur diese 5 Rechte vorhanden sind:
Get-ManagementRoleEntry "Contact-Editors1\*"

# Nun kann man noch einen neuen Management Scope hinzufügen, damit der User auch nur die Kontakte sieht:
New-ManagementScope -Name MailContacts -RecipientRestrictionFilter {RecipientType -eq "MailContacts"} 

# Als nächstes werden diese beide Management Rollen einer Admin Rolle hinzugefügt und mit dem neu erstellten Scope versehen. Dies kann man nun gut in der O365 Admin Oberfläche machen...